/*!
 * Copyright (c) 2012 - 2023, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  let define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"96c70351f1": function _(e,a,c,t,i){t();const s=e("642e37ebf7");i("DataPipe",s.DataPipe);const r=e("6855a0453c");i("ImagePipe",r.ImagePipe);const o=e("6d05c9f71b");i("ImageDataSource",o.ImageDataSource);const p=e("224acccf0a");i("SpectraDataSource",p.SpectraDataSource);const D=e("b6d0976db1");i("WcsTicks",D.WcsTicks);const S=e("e3901fa9f2");i("serialize",S.serialize),i("deserialize",S.deserialize);(0,e("@bokehjs/base").register_models)({DataPipe:s.DataPipe,ImagePipe:r.ImagePipe,ImageDataSource:o.ImageDataSource,SpectraDataSource:p.SpectraDataSource,WcsTicks:D.WcsTicks})},
"642e37ebf7": function _(e,s,i,t,n){var o;t();const c=e("@bokehjs/models/sources/data_source"),a=e("e3901fa9f2");class d extends c.DataSource{constructor(e){super(e),this.send_queue={},this.connection_queue=[],this.pending={},this.incoming_callbacks={}}initialize(){super.initialize();let e=`ws://${this.address[0]}:${this.address[1]}`;console.log("datapipe url:",e);var s=void 0;document.shutdown_in_progress_=!1;var i=()=>{void 0!==this.websocket&&this.websocket.close(),this.websocket=new WebSocket(e),this.websocket.binaryType="arraybuffer",this.websocket.onerror=e=>{console.log("error encountered:",e)},this.websocket.onmessage=e=>{if("string"==typeof e.data||e.data instanceof String){let s=(0,a.deserialize)(e.data);if("id"in s&&"direction"in s&&"message"in s){let{id:e,message:i,direction:t}=s;if(void 0===i&&console.log("Error, event failure",s),"j2p"==t)if(e in this.pending){let{cb:t}=this.pending[e];if(delete this.pending[e],e in this.send_queue&&this.send_queue[e].length>0){let{cb:s,msg:i}=this.send_queue[e].shift();this.pending[e]={cb:s},this.websocket.send((0,a.serialize)(i))}void 0===i?console.log("DROPPING ERROR FOR NOW (maybe need error callbacks)",s):t(i)}else console.log("message received but could not find id");else if(e in this.incoming_callbacks){let s=this.incoming_callbacks[e](i);this.websocket.send((0,a.serialize)({id:e,direction:t,message:s,session:object_id(this)}))}}else console.log(`datapipe received message without one of 'id', 'message' or 'direction': ${s}`)}else console.log("datapipe received binary data",e.data.byteLength,"bytes")},this.websocket.onopen=()=>{for(s?0==s.connected&&console.log(`connection reestablished at ${new Date}`):this.websocket.send((0,a.serialize)({id:"initialize",direction:"j2p",session:object_id(this)})),s=new ReconnectState;this.connection_queue.length>0;){let e=this.connection_queue.shift();this.send.apply(e[0],e[1])}},this.websocket.onclose=()=>{if(1==s.connected&&(console.log(`connection lost at ${new Date}`),s.connected=!1,!document.shutdown_in_progress_)){console.log(`connection lost at ${new Date}`);var e=s;function t(n){0==s.connected&&(console.log(`${n+1}\treconnection attempt ${new Date}`),i(),e.backoff(),e.retries>0?setTimeout(t,e.timeout,n+1):0==s.connected&&console.log(`aborting reconnection after ${n} attempts ${new Date}`))}t(0)}}};i();(()=>{null!=this.init_script&&this.init_script.execute(this)})()}register(e,s){this.incoming_callbacks[e]=s}send(e,s,i,t=!1){let n={id:e,message:s,direction:"j2p",session:object_id(this)};if(!this.websocket||e in this.pending)if(e in this.send_queue)if("boolean"==typeof t&&t&&this.send_queue[e].length>0)this.send_queue[e][0].msg=n,this.send_queue[e][0].cb=i;else if("function"==typeof t&&this.send_queue[e].length>0){let s=!1;for(const o of this.send_queue[e])t(o.msg.message)&&(o.msg=n,o.cb=i,s=!0);s||this.send_queue[e].push({cb:i,msg:n})}else this.send_queue[e].push({cb:i,msg:n});else this.send_queue[e]=[{cb:i,msg:n}];else if(this.websocket.readyState===WebSocket.CONNECTING)this.connection_queue.push([this,[e,s,i]]);else if(e in this.send_queue&&this.send_queue[e].length>0){this.send_queue[e].push({cb:i,msg:n});{let{cb:s,msg:i}=this.send_queue[e].shift();this.pending[e]={cb:s},this.websocket.send((0,a.serialize)(i))}}else this.pending[e]={cb:i},this.websocket.send((0,a.serialize)(n))}}i.DataPipe=d,o=d,d.__name__="DataPipe",d.__module__="casagui.bokeh.sources._data_pipe",o.define((({Any:e,Tuple:s,String:i,Number:t})=>({init_script:[e,null],address:[s(i,t)]})))},
"e3901fa9f2": function _(e,r,s,i,o){i();const l=e("@bokehjs/base"),a=e("@bokehjs/core/resolvers"),t=e("@bokehjs/core/serialization/deserializer"),n=e("@bokehjs/core/serialization/serializer"),{deserialize:c}=new class{constructor(){this.resolver=new a.ModelResolver(l.default_resolver),this.deserializer=new t.Deserializer(this.resolver),this.deserialize=e=>{try{return this.deserializer.decode(JSON.parse(e))}catch(r){return console.group("deserialize error"),console.log(e),console.log(r),console.groupEnd(),{}}}}};s.deserialize=c;const{serialize:z}=new class{constructor(){this.serializer=new n.Serializer,this.serialize=e=>JSON.stringify(this.serializer.encode(e))}};s.serialize=z},
"6855a0453c": function _(e,i,s,t,n){var a;t();const d=e("642e37ebf7");class o extends d.DataPipe{constructor(e){super(e),this.position={},this._wcs=null}initialize(){super.initialize(),this.fits_header_json&&(this._wcs=new window.coordtxl.WCSTransform(new window.coordtxl.MapKeywordProvider(JSON.parse(this.fits_header_json))))}channel(e,i,s){this.position[s]={index:e};let t={action:"channel",index:e,id:s};super.send(this.dataid,t,i)}spectra(e,i,s,t=!1){let n={action:"spectra",index:e,id:s};super.send(this.dataid,n,i,t)}refresh(e,i,s=[0,0]){let{index:t}=i in this.position?this.position[i]:{index:s};if(2===t.length){let s={action:"channel",index:t,id:i};super.send(this.dataid,s,e)}else if(3===t.length){let s={action:"spectra",index:t,id:i};super.send(this.dataid,s,e)}}wcs(){return this._wcs}}s.ImagePipe=o,a=o,o.__name__="ImagePipe",o.__module__="casagui.bokeh.sources._image_pipe",a.define((({Number:e,Nullable:i,String:s,Tuple:t})=>({dataid:[s],shape:[t(e,e,e,e)],fits_header_json:[i(s),null]})))},
"6d05c9f71b": function _(s,a,o,c,e){var i;c();const n=s("@bokehjs/models/sources/column_data_source"),t=s("@bokehjs/core/util/string"),u=s("6855a0453c");class r extends n.ColumnDataSource{constructor(s){super(s),this.imid=(0,t.uuid4)()}initialize(){super.initialize();(()=>{null!=this.init_script&&this.init_script.execute(this)})()}_mask_contour(s){const a=window.contours().size(this.image_source.shape.slice(0,2)).thresholds([1])(s[0])[0].coordinates.map((s=>s.map((s=>s.reduce(((s,a)=>(s[0].push(a[0]),s[1].push(a[1]),s)),[[],[]])))));return{xs:[a.map((s=>s.map((s=>s[0]))))],ys:[a.map((s=>s.map((s=>s[1]))))]}}channel(s,a=0,o){this.image_source.channel([a,s],(c=>{void 0!==c&&void 0!==c.chan||console.log("ImageDataSource ERROR ENCOUNTERED <1>",c),this.cur_chan=[a,s],null!=this._mask_contour_source&&"chan"in c&&"msk"in c.chan&&(c.msk_contour=this._mask_contour(c.chan.msk),this._mask_contour_source.data=c.msk_contour),o&&o(c),this.data=c.chan}),this.imid)}signal_change(){this.change.emit()}refresh(s){this.image_source.refresh((a=>{void 0!==a&&void 0!==a.chan||console.log("ImageDataSource ERROR ENCOUNTERED <2>",a),null!=this._mask_contour_source&&"chan"in a&&"msk"in a.chan&&(a.msk_contour=this._mask_contour(a.chan.msk),this._mask_contour_source.data=a.msk_contour),s&&s(a),this.data=a.chan}),this.imid,[0,0])}wcs(){return this.image_source.wcs()}}o.ImageDataSource=r,i=r,r.__name__="ImageDataSource",r.__module__="casagui.bokeh.sources._image_data_source",i.define((({Tuple:s,Number:a,Ref:o,Any:c})=>({init_script:[c,null],image_source:[o(u.ImagePipe)],_mask_contour_source:[o(n.ColumnDataSource),null],num_chans:[s(a,a)],cur_chan:[s(a,a)]})))},
"224acccf0a": function _(e,s,a,i,t){var r;i();const c=e("@bokehjs/models/sources/column_data_source"),u=e("@bokehjs/core/util/string"),o=e("6855a0453c");class _ extends c.ColumnDataSource{constructor(e){super(e),this.imid=(0,u.uuid4)()}initialize(){super.initialize()}spectra(e,s,a=0,i=!1){this.image_source.spectra([e,s,a],(e=>this.data=e.spectrum),this.imid,i)}refresh(){this.image_source.refresh((e=>this.data=e.spectrum),this.imid,[0,0,0])}}a.SpectraDataSource=_,r=_,_.__name__="SpectraDataSource",_.__module__="casagui.bokeh.sources._spectra_data_source",r.define((({Ref:e})=>({image_source:[e(o.ImagePipe)]})))},
"b6d0976db1": function _(o,s,i,t,e){var r;t();const a=o("@bokehjs/models/formatters/tick_formatter"),c=o("6d05c9f71b");class d extends a.TickFormatter{constructor(o){super(o),this._axis=null,this._coord="world"}initialize(){super.initialize(),"x"==this.axis||"X"==this.axis||"y"==this.axis||"Y"==this.axis?this._axis="x"==this.axis||"X"==this.axis?"x":"y":console.log("ERROR: WcsTicks formatter created with invalid axis:",this.axis)}doFormat(o){const s=[];if(this._axis&&this.image_source.wcs()&&"world"==this._coord)for(let i=0,t=o.length;i<t;i++)if("x"==this._axis){const t=new window.coordtxl.Point2D(Number(o[i]),0);this.image_source.wcs().imageToWorldCoords(t,!1),s.push(new window.coordtxl.WorldCoords(t.getX(),t.getY()).format(2e3)[0])}else{const t=new window.coordtxl.Point2D(0,Number(o[i]));this.image_source.wcs().imageToWorldCoords(t,!1),s.push(new window.coordtxl.WorldCoords(t.getX(),t.getY()).format(2e3)[1])}else for(let i=0,t=o.length;i<t;i++)s.push(""+o[i]);return s}coordinates(o){return o!=this._coord&&("world"!=o&&"pixel"!=o||(this._coord=o)),this._coord}}i.WcsTicks=d,r=d,d.__name__="WcsTicks",d.__module__="casagui.bokeh.format._wcs_ticks",r.define((({Ref:o,String:s})=>({axis:[s],image_source:[o(c.ImageDataSource)]})))},
}, "96c70351f1", {"index":"96c70351f1","src/bokeh/sources/data_pipe":"642e37ebf7","src/bokeh/util/conversions":"e3901fa9f2","src/bokeh/sources/image_pipe":"6855a0453c","src/bokeh/sources/image_data_source":"6d05c9f71b","src/bokeh/sources/spectra_data_source":"224acccf0a","src/bokeh/format/wcs_ticks":"b6d0976db1"}, {});});
